<?php

namespace Bydedi\Flux\GoogleShopping\Exception;

use Exception;

/**
 * Class UnauthorizedValueException
 * @package Bydedi\Flux\GoogleShopping\Exception
 */
class UnauthorizedValueException extends Exception
{

    /**
     * UnauthorizedValueException constructor.
     * @param string $paramName
     * @param int $value
     * @param array $authorizedValues
     * @param int $code
     * @param Exception|null $previous
     */
    public function __construct($paramName, $value, $authorizedValues = array(), $code = 0, Exception $previous = null)
    {
        $message = sprintf("Wrong value for param %s. You passed : %s.", $paramName, $value);

        if (!empty($authorizedValues) && is_array($authorizedValues)) {
            $message .= sprintf(" Values authorized : %s.", implode(" / ", $authorizedValues));
        }

        parent::__construct($message, $code, $previous);
    }

    /**
     * @return string
     */
    public function __toString()
    {
        return __CLASS__ . ": [{$this->code}]: {$this->message}\n";
    }
}